/**
 * Tightness section of Enslavement, Night One.
 * @param {CaravanConfinementController} controller The Enslavement, Night One controller.
 */
function CaravanConfinementClaw(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = CaravanConfinementTightnessChoice.CLAW;
    var reqController = ctrl.tight;
    var subController = ctrl.postTight;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new CaravanConfinementCart(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var male = ctrl.misc.baseGender() === GenderEnum.MALE;
        var fucked = global.kobold.history.shared.enslavement.captureFucked;
        var toReturn = `[p]
                            You aren't going to let this filthy [b]slaver[/b] touch you!
                            You'd rather [b]get your neck snapped[/b] by the wolf standing behind you than let some disgusting,
                            mean, [b]rude[/b] human lay his hands upon you!
                            As he reaches for your groin, you raise your arm threateningly, preparing to [b]maim[/b] his face with your sharp claws.
                            Mere moments before you manage to bring your natural weapons to bear, your wrist is grabbed from behind by a powerful, furred hand.
                        [/p]
                        [p]
                            The wolf, still holding your tail, restrains you, preventing you from striking your target.
                            You aren't stopped that easily, though.
                            You lift your [i]other[/i] hand, determined to [b]hurt[/b] the caravan master.
                            A second time, however, you are interrupted mid-strike.
                        [/p]
                        [p]
                            Rather than taking hold of your other wrist as well, the canine chooses to simply [b]squeeze[/b] the small scaly arm already in his grasp.
                            You wince in pain, the bandit's powerful grip making it [b]very[/b] clear that he could snap your bones like [b]twigs[/b].
                            "[color=gblue][b]Don't[/b].[/color]" he states, and nothing more.
                            Whimpering and whining, you meekly lower your free hand once more, and relent to the humiliating inspection.
                        [/p]
                        [p]
                            Tears form at the corners of your eyes, not from pain, but from [b]shame[/b].
                            Shame that you are going to [b]let this happen[/b],
                            instead of struggling so hard they're forced to beat you to a [b]bloody pulp[/b] before being able to check your loins.
                        [/p]
                        [p]
                            A knight would fight to the very end before suffering indignation at the hands of ${male ? `his` : `her`} captors.
                            But, despite your best hopes and dreams, you are no knight.
                            You are a [b]thief[/b], and now a [b]slave[/b].
                            A [b]coward[/b], scared of getting hurt.
                            A weakling that yields in the face of adversity, instead of rising beyond and above.
                        [/p]
                        [p]
                            If you were stronger, more agile, smarter perhaps, there might have been a way out of this situation.
                            But for a frail kobold like yourself, all you can do is resign to your fate,
                            and hope that the human kneeling before you will stay true to his word instead of taking things [i]one step further[/i].
                        [/p]`;

        if (fucked && male) {
            toReturn += `[p]
                            As your tears drip to the ground, the caravan master begins his [i]inspection[/i].
                            A single, probing finger slides over the scales of your nether region.
                            First, it makes its way towards your rear, rubbing over your still-sensitive butthole.
                            Even without slipping the digit inside,
                            the caravan master can clearly tell that this part of your body won't be a prominent selling point,
                            at least not for a couple of days more, when it'll regain its tightness.
                        [/p]
                        [p]
                            He sighs loudly, before moving his finger a bit more to the front, pressing it against your virginal cockslit.
                            The human stares directly into your eyes.
                            A small smirk forms on his face.
                            Then, he slips the tip of the chubby digit inside of your warm slit,
                            testing the tightness of an orifice that was never meant to be fucked.
                        [/p]
                        [p]
                            "[color=brown]You could pass for a maiden if there wasn't a dick in there.[/color]" the caravan master speaks,
                            elliciting a chuckle from the wolf.
                            "[color=gblue]Well, now I know which hole I'll be fucking if you don't sell, kobold.[/color]"
                        [/p]`;
        } else if (fucked && !male) {
            toReturn += `[p]
                            As your tears drip to the ground, the caravan master begins his [i]inspection[/i].
                            A single, probing finger slides over the scales of your nether region.
                            First, it travels along the length of your slit, parting your folds ever so slightly.
                            Even without slipping the digit inside,
                            the caravan master can clearly tell that this part of your body won't be a prominent selling point,
                            at least not for a couple of days more, when it'll regain its tightness.
                        [/p]
                        [p]
                            He sighs loudly, before moving his finger a bit more to the rear, pressing it against your virginal tailhole.
                            The human stares directly into your eyes.
                            A small smirk forms on his face.
                            Then, he slips the tip of the chubby digit inside of your butt,
                            testing the tightness of an orifice that was never meant to be fucked.
                        [/p]
                        [p]
                            "[color=brown]Tighter than a monk's lips.[/color]" the caravan master speaks,
                            elliciting a chuckle from the wolf.
                            "[color=gblue]Well, now I know which hole I'll be fucking if you don't sell, kobold.[/color]"
                        [/p]`;
        } else if (!fucked && male) {
            toReturn += `[p]
                            As your tears drip to the ground, the caravan master begins his [i]inspection[/i].
                            A single, probing finger slides over the scales of your nether region.
                            It makes its way towards your rear, rubbing over your virginal butthole.
                        [/p]
                        [p]
                            Even without slipping the digit inside,
                            the caravan master can clearly tell that this part of your body could be a prominent selling point,
                            but he isn't content with just [b]touching[/b].
                            The human stares directly into your eyes.
                            A small smirk forms on his face.
                            Then, he presses the tip of his chubby finger inside of your butt,
                            testing the tightness of a virginal kobold.
                        [/p]
                        [p]
                            "[color=brown]Looks like he wasn't lying after all.[/color]" the caravan master speaks.
                            "[color=brown]A virgin kobold, a rarity for sure.
                            I have no doubt you'll sell well.[/color]"
                            The wolf chuckles, quickly adding:
                            "[color=gblue]And if you don't, you won't be a virgin for much longer.[/color]"
                            The canine gives a teasing thrust from behind, bumping his clothed groin against the back of your head.
                        [/p]`;
        } else {
            toReturn += `[p]
                            As your tears drip to the ground, the caravan master begins his [i]inspection[/i].
                            A single, probing finger slides over the scales of your nether region.
                            It travls along the length of your slit, parting your folds ever so slightly.
                        [/p]
                        [p]
                            Even without slipping the digit inside,
                            the caravan master can clearly tell that this part of your body could be a prominent selling point,
                            but he isn't content with just [b]touching[/b].
                            The human stares directly into your eyes.
                            A small smirk forms on his face.
                            Then, he presses the tip of his chubby finger inside of your cunt,
                            testing the tightness of a virginal kobold.
                        [/p]
                        [p]
                            "[color=brown]Looks like she wasn't lying after all.[/color]" the caravan master speaks.
                            "[color=brown]A virgin kobold, a rarity for sure.
                            I have no doubt you'll sell well.[/color]"
                            The wolf chuckles, quickly adding:
                            "[color=gblue]And if you don't, you won't be a virgin for much longer.[/color]"
                            The canine gives a teasing thrust from behind, bumping his clothed groin against the back of your head.
                        [/p]`;
        }

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += subController.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
